#ifndef _Xlib_stub_ffi_h
#define _Xlib_stub_ffi_h
#include "cbits/HsXlib.h"
#include "HsFFI.h"
extern void prim_writeAddr(void** s,int i,void* v);
extern void * prim_readAddr(void** s,int i);
extern void * prim_allocAddr(int arg1);
extern void prim_writePoint(XPoint* s,int i,int gc_arg3,int gc_arg5);
extern void* prim_readPoint(XPoint* s,int i);
extern int access_prim_readPoint_gc_res2(HsPtr);
extern int access_prim_readPoint_gc_res4(HsPtr);
extern void * prim_allocPoints(int arg1);
extern void prim_writeRectangle(XRectangle* s,int i,int gc_arg3,int gc_arg5,unsigned int gc_arg6,unsigned int gc_arg7);
extern void* prim_readRectangle(XRectangle* s,int i);
extern int access_prim_readRectangle_gc_res2(HsPtr);
extern int access_prim_readRectangle_gc_res4(HsPtr);
extern unsigned int access_prim_readRectangle_gc_res5(HsPtr);
extern unsigned int access_prim_readRectangle_gc_res6(HsPtr);
extern void * prim_allocRectangles(int arg1);
extern void prim_writeArc(XArc* s,int i,int gc_arg3,int gc_arg5,unsigned int gc_arg6,unsigned int gc_arg7,int gc_arg8,int gc_arg9);
extern void* prim_readArc(XArc* s,int i);
extern int access_prim_readArc_gc_res2(HsPtr);
extern int access_prim_readArc_gc_res4(HsPtr);
extern unsigned int access_prim_readArc_gc_res5(HsPtr);
extern unsigned int access_prim_readArc_gc_res6(HsPtr);
extern int access_prim_readArc_gc_res7(HsPtr);
extern int access_prim_readArc_gc_res8(HsPtr);
extern void * prim_allocArcs(int arg1);
extern void prim_writeSegment(XSegment* s,int i,int gc_arg3,int gc_arg5,int gc_arg7,int gc_arg9);
extern void* prim_readSegment(XSegment* s,int i);
extern int access_prim_readSegment_gc_res2(HsPtr);
extern int access_prim_readSegment_gc_res4(HsPtr);
extern int access_prim_readSegment_gc_res6(HsPtr);
extern int access_prim_readSegment_gc_res8(HsPtr);
extern void * prim_allocSegments(int arg1);
extern void prim_writeColor(XColor* s,int i,unsigned int gc_arg2,unsigned int gc_arg4,unsigned int gc_arg6,unsigned int gc_arg8,unsigned int gc_arg10);
extern void* prim_readColor(XColor* s,int i);
extern unsigned int access_prim_readColor_gc_res1(HsPtr);
extern unsigned int access_prim_readColor_gc_res3(HsPtr);
extern unsigned int access_prim_readColor_gc_res5(HsPtr);
extern unsigned int access_prim_readColor_gc_res7(HsPtr);
extern unsigned int access_prim_readColor_gc_res9(HsPtr);
extern void * prim_allocColors(int arg1);
extern void prim_writeWord32(unsigned int* s,int i,unsigned int v);
extern unsigned int prim_readWord32(unsigned int* s,int i);
extern unsigned int* prim_allocWord32Star(int arg1);
extern unsigned int prim_allPlanes();
extern unsigned int prim_blackPixel(Display* arg1,unsigned int arg2);
extern unsigned int prim_whitePixel(Display* arg1,unsigned int arg2);
extern int prim_connectionNumber(Display* arg1);
extern XID prim_defaultColormap(Display* arg1,unsigned int arg2);
extern void * prim_defaultGC(Display* arg1,unsigned int arg2);
extern int prim_defaultDepth(Display* arg1,unsigned int arg2);
extern unsigned int prim_defaultScreen(Display* arg1);
extern Screen* prim_defaultScreenOfDisplay(Display* arg1);
extern int prim_displayHeight(Display* arg1,unsigned int arg2);
extern int prim_displayHeightMM(Display* arg1,unsigned int arg2);
extern int prim_displayWidth(Display* arg1,unsigned int arg2);
extern int prim_displayWidthMM(Display* arg1,unsigned int arg2);
extern int prim_maxRequestSize(Display* arg1);
extern int prim_displayMotionBufferSize(Display* arg1);
extern char * prim_resourceManagerString(Display* arg1);
extern char * prim_screenResourceString(Screen* arg1);
extern char * prim_displayString(Display* arg1);
extern int prim_imageByteOrder(Display* arg1);
extern int prim_protocolRevision(Display* arg1);
extern int prim_protocolVersion(Display* arg1);
extern char * prim_serverVendor(Display* arg1);
extern int prim_screenCount(Display* arg1);
extern Visual* prim_defaultVisual(Display* arg1,unsigned int arg2);
extern int prim_displayCells(Display* arg1,unsigned int arg2);
extern int prim_displayPlanes(Display* arg1,unsigned int arg2);
extern Screen* prim_screenOfDisplay(Display* arg1,unsigned int arg2);
extern XID prim_defaultRootWindow(Display* arg1);
extern XID prim_rootWindow(Display* arg1,unsigned int arg2);
extern int prim_qLength(Display* arg1);
extern void prim_noOp(Display* arg1);
extern void* prim_openDisplay(char * arg1);
extern Display* access_prim_openDisplay_res1(HsPtr);
extern int access_prim_openDisplay_gc_failed(HsPtr);
extern void* access_prim_openDisplay_gc_failstring(HsPtr);
extern void prim_closeDisplay(Display* arg1);
extern void prim_rmInitialize();
extern void prim_autoRepeatOff(Display* arg1);
extern void prim_autoRepeatOn(Display* arg1);
extern void prim_bell(Display* arg1,int arg2);
extern void prim_setCloseDownMode(Display* arg1,int arg2);
extern int prim_lastKnownRequestProcessed(Display* arg1);
extern void* prim_getInputFocus(Display* arg1);
extern XID access_prim_getInputFocus_res1(HsPtr);
extern int access_prim_getInputFocus_res2(HsPtr);
extern void prim_setInputFocus(Display* arg1,XID arg2,int arg3,Time arg4);
extern void prim_grabButton(Display* arg1,unsigned int arg2,unsigned int arg3,XID arg4,int arg5,unsigned int arg6,int arg7,int arg8,XID arg9,XID arg10);
extern void prim_ungrabButton(Display* arg1,unsigned int arg2,unsigned int arg3,XID arg4);
extern int prim_grabPointer(Display* arg1,XID arg2,int arg3,unsigned int arg4,int arg5,int arg6,XID arg7,XID arg8,Time arg9);
extern void prim_ungrabPointer(Display* arg1,Time arg2);
extern void prim_grabKey(Display* arg1,KeyCode arg2,unsigned int arg3,XID arg4,int arg5,int arg6,int arg7);
extern void prim_ungrabKey(Display* arg1,KeyCode arg2,unsigned int arg3,XID arg4);
extern int prim_grabKeyboard(Display* arg1,XID arg2,int arg3,int arg4,int arg5,Time arg6);
extern void prim_ungrabKeyboard(Display* arg1,Time arg2);
extern void prim_grabServer(Display* arg1);
extern void prim_ungrabServer(Display* arg1);
extern void* prim_queryBestTile(Display* arg1,XID arg2,unsigned int arg3,unsigned int arg4);
extern unsigned int access_prim_queryBestTile_res1(HsPtr);
extern unsigned int access_prim_queryBestTile_res2(HsPtr);
extern int access_prim_queryBestTile_gc_failed(HsPtr);
extern void* access_prim_queryBestTile_gc_failstring(HsPtr);
extern void* prim_queryBestStipple(Display* arg1,XID arg2,unsigned int arg3,unsigned int arg4);
extern unsigned int access_prim_queryBestStipple_res1(HsPtr);
extern unsigned int access_prim_queryBestStipple_res2(HsPtr);
extern int access_prim_queryBestStipple_gc_failed(HsPtr);
extern void* access_prim_queryBestStipple_gc_failstring(HsPtr);
extern void* prim_queryBestCursor(Display* arg1,XID arg2,unsigned int arg3,unsigned int arg4);
extern unsigned int access_prim_queryBestCursor_res1(HsPtr);
extern unsigned int access_prim_queryBestCursor_res2(HsPtr);
extern int access_prim_queryBestCursor_gc_failed(HsPtr);
extern void* access_prim_queryBestCursor_gc_failstring(HsPtr);
extern void* prim_queryBestSize(Display* arg1,XID arg2,int arg3,unsigned int arg4,unsigned int arg5);
extern unsigned int access_prim_queryBestSize_res1(HsPtr);
extern unsigned int access_prim_queryBestSize_res2(HsPtr);
extern int access_prim_queryBestSize_gc_failed(HsPtr);
extern void* access_prim_queryBestSize_gc_failstring(HsPtr);
extern void* prim_queryPointer(Display* arg1,XID arg2);
extern int access_prim_queryPointer_res1(HsPtr);
extern XID access_prim_queryPointer_res2(HsPtr);
extern XID access_prim_queryPointer_res3(HsPtr);
extern int access_prim_queryPointer_res4(HsPtr);
extern int access_prim_queryPointer_res5(HsPtr);
extern int access_prim_queryPointer_res6(HsPtr);
extern int access_prim_queryPointer_res7(HsPtr);
extern unsigned int access_prim_queryPointer_res8(HsPtr);
extern char * prim_displayName(char * arg1);
extern void prim_setDefaultErrorHandler();
extern int prim_queuedAlready();
extern int prim_queuedAfterFlush();
extern int prim_queuedAfterReading();
extern XEvent* prim_allocXEvent();
extern unsigned int prim_get_EventType(XEvent* arg1);
extern XID prim_get_Window(XEvent* arg1);
extern void* prim_get_KeyEvent(XEvent* arg1);
extern XID access_prim_get_KeyEvent_gc_res1(HsPtr);
extern XID access_prim_get_KeyEvent_gc_res2(HsPtr);
extern Time access_prim_get_KeyEvent_gc_res3(HsPtr);
extern int access_prim_get_KeyEvent_gc_res4(HsPtr);
extern int access_prim_get_KeyEvent_gc_res5(HsPtr);
extern int access_prim_get_KeyEvent_gc_res6(HsPtr);
extern int access_prim_get_KeyEvent_gc_res7(HsPtr);
extern unsigned int access_prim_get_KeyEvent_gc_res8(HsPtr);
extern KeyCode access_prim_get_KeyEvent_gc_res9(HsPtr);
extern int access_prim_get_KeyEvent_gc_res11(HsPtr);
extern void* prim_get_ButtonEvent(XEvent* arg1);
extern XID access_prim_get_ButtonEvent_gc_res1(HsPtr);
extern XID access_prim_get_ButtonEvent_gc_res2(HsPtr);
extern Time access_prim_get_ButtonEvent_gc_res3(HsPtr);
extern int access_prim_get_ButtonEvent_gc_res4(HsPtr);
extern int access_prim_get_ButtonEvent_gc_res5(HsPtr);
extern int access_prim_get_ButtonEvent_gc_res6(HsPtr);
extern int access_prim_get_ButtonEvent_gc_res7(HsPtr);
extern unsigned int access_prim_get_ButtonEvent_gc_res8(HsPtr);
extern unsigned int access_prim_get_ButtonEvent_gc_res9(HsPtr);
extern int access_prim_get_ButtonEvent_gc_res11(HsPtr);
extern void* prim_get_MotionEvent(XEvent* arg1);
extern XID access_prim_get_MotionEvent_gc_res1(HsPtr);
extern XID access_prim_get_MotionEvent_gc_res2(HsPtr);
extern Time access_prim_get_MotionEvent_gc_res3(HsPtr);
extern int access_prim_get_MotionEvent_gc_res4(HsPtr);
extern int access_prim_get_MotionEvent_gc_res5(HsPtr);
extern int access_prim_get_MotionEvent_gc_res6(HsPtr);
extern int access_prim_get_MotionEvent_gc_res7(HsPtr);
extern unsigned int access_prim_get_MotionEvent_gc_res8(HsPtr);
extern int access_prim_get_MotionEvent_gc_res9(HsPtr);
extern int access_prim_get_MotionEvent_gc_res11(HsPtr);
extern void* prim_get_ExposeEvent(XEvent* arg1);
extern int access_prim_get_ExposeEvent_gc_res2(HsPtr);
extern int access_prim_get_ExposeEvent_gc_res4(HsPtr);
extern unsigned int access_prim_get_ExposeEvent_gc_res5(HsPtr);
extern unsigned int access_prim_get_ExposeEvent_gc_res6(HsPtr);
extern int access_prim_get_ExposeEvent_gc_res7(HsPtr);
extern void* prim_get_ConfigureEvent(XEvent* arg1);
extern int access_prim_get_ConfigureEvent_gc_res2(HsPtr);
extern int access_prim_get_ConfigureEvent_gc_res4(HsPtr);
extern unsigned int access_prim_get_ConfigureEvent_gc_res5(HsPtr);
extern unsigned int access_prim_get_ConfigureEvent_gc_res6(HsPtr);
extern int prim_waitForEvent(Display* arg1,unsigned int arg2);
extern void* prim_gettimeofday_in_milliseconds_internal();
extern unsigned int access_prim_gettimeofday_in_milliseconds_internal_res1(HsPtr);
extern unsigned int access_prim_gettimeofday_in_milliseconds_internal_res2(HsPtr);
extern void prim_flush(Display* arg1);
extern void prim_sync(Display* arg1,int arg2);
extern int prim_pending(Display* arg1);
extern int prim_eventsQueued(Display* arg1,int arg2);
extern void prim_nextEvent(Display* arg1,XEvent* arg2);
extern void prim_allowEvents(Display* arg1,int arg2,Time arg3);
extern void prim_selectInput(Display* arg1,XID arg2,unsigned int arg3);
extern void* prim_sendEvent(Display* arg1,XID arg2,int arg3,unsigned int arg4,XEvent* arg5);
extern int access_prim_sendEvent_gc_failed(HsPtr);
extern void* access_prim_sendEvent_gc_failstring(HsPtr);
extern void prim_windowEvent(Display* arg1,XID arg2,unsigned int arg3,XEvent* arg4);
extern int prim_checkWindowEvent(Display* arg1,XID arg2,unsigned int arg3,XEvent* arg4);
extern void prim_maskEvent(Display* arg1,unsigned int arg2,XEvent* arg3);
extern int prim_checkMaskEvent(Display* arg1,unsigned int arg2,XEvent* arg3);
extern int prim_checkTypedEvent(Display* arg1,unsigned int arg2,XEvent* arg3);
extern int prim_checkTypedWindowEvent(Display* arg1,XID arg2,unsigned int arg3,XEvent* arg4);
extern void prim_putBackEvent(Display* arg1,XEvent* arg2);
extern void prim_peekEvent(Display* arg1,XEvent* arg2);
extern void prim_refreshKeyboardMapping(int gc_arg2,KeyCode gc_arg3,int gc_arg4);
extern void* prim_geometry(Display* arg1,int arg2,char * arg3,char * arg4,unsigned int arg5,unsigned int arg6,unsigned int arg7,int arg8,int arg9);
extern int access_prim_geometry_res1(HsPtr);
extern int access_prim_geometry_res2(HsPtr);
extern int access_prim_geometry_res3(HsPtr);
extern unsigned int access_prim_geometry_res4(HsPtr);
extern unsigned int access_prim_geometry_res5(HsPtr);
extern void* prim_getGeometry(Display* arg1,int arg2,XID arg3);
extern XID access_prim_getGeometry_res1(HsPtr);
extern int access_prim_getGeometry_res2(HsPtr);
extern int access_prim_getGeometry_res3(HsPtr);
extern unsigned int access_prim_getGeometry_res4(HsPtr);
extern unsigned int access_prim_getGeometry_res5(HsPtr);
extern unsigned int access_prim_getGeometry_res6(HsPtr);
extern int access_prim_getGeometry_res7(HsPtr);
extern int access_prim_getGeometry_gc_failed(HsPtr);
extern void* access_prim_getGeometry_gc_failstring(HsPtr);
extern int prim_supportsLocale();
extern char * prim_setLocaleModifiers(char * arg1);
extern int prim_dontAllowExposures();
extern int prim_allowExposures();
extern int prim_defaultExposures();
extern int prim_dontPreferBlanking();
extern int prim_preferBlanking();
extern int prim_defaultBlanking();
extern int prim_screenSaverActive();
extern int prim_screenSaverReset();
extern void* prim_getScreenSaver(Display* arg1);
extern int access_prim_getScreenSaver_res1(HsPtr);
extern int access_prim_getScreenSaver_res2(HsPtr);
extern int access_prim_getScreenSaver_res3(HsPtr);
extern int access_prim_getScreenSaver_res4(HsPtr);
extern void prim_setScreenSaver(Display* arg1,int arg2,int arg3,int arg4,int arg5);
extern void prim_activateScreenSaver(Display* arg1);
extern void prim_resetScreenSaver(Display* arg1);
extern void prim_forceScreenSaver(Display* arg1,int arg2);
extern void* prim_getPointerControl(Display* arg1);
extern int access_prim_getPointerControl_res1(HsPtr);
extern int access_prim_getPointerControl_res2(HsPtr);
extern int access_prim_getPointerControl_res3(HsPtr);
extern void prim_warpPointer(Display* arg1,XID arg2,XID arg3,int arg4,int arg5,unsigned int arg6,unsigned int arg7,int arg8,int arg9);
extern unsigned int prim_blackPixelOfScreen(Screen* arg1);
extern unsigned int prim_whitePixelOfScreen(Screen* arg1);
extern int prim_cellsOfScreen(Screen* arg1);
extern XID prim_defaultColormapOfScreen(Screen* arg1);
extern int prim_defaultDepthOfScreen(Screen* arg1);
extern void * prim_defaultGCOfScreen(Screen* arg1);
extern Visual* prim_defaultVisualOfScreen(Screen* arg1);
extern int prim_doesBackingStore(Screen* arg1);
extern int prim_doesSaveUnders(Screen* arg1);
extern Display* prim_displayOfScreen(Screen* arg1);
extern unsigned int prim_eventMaskOfScreen(Screen* arg1);
extern int prim_minCmapsOfScreen(Screen* arg1);
extern int prim_maxCmapsOfScreen(Screen* arg1);
extern XID prim_rootWindowOfScreen(Screen* arg1);
extern unsigned int prim_widthOfScreen(Screen* arg1);
extern unsigned int prim_widthMMOfScreen(Screen* arg1);
extern unsigned int prim_heightOfScreen(Screen* arg1);
extern unsigned int prim_heightMMOfScreen(Screen* arg1);
extern int prim_planesOfScreen(Screen* arg1);
extern unsigned int prim_screenNumberOfScreen(Screen* arg1);
extern void prim_setArcMode(Display* arg1,void * arg2,int arg3);
extern void prim_setBackground(Display* arg1,void * arg2,unsigned int arg3);
extern void prim_setForeground(Display* arg1,void * arg2,unsigned int arg3);
extern void prim_setFunction(Display* arg1,void * arg2,int arg3);
extern void prim_setGraphicsExposures(Display* arg1,void * arg2,int arg3);
extern void prim_setClipMask(Display* arg1,void * arg2,XID arg3);
extern void prim_setClipOrigin(Display* arg1,void * arg2,int arg3,int arg4);
extern void prim_setDashes(Display* arg1,void * arg2,int arg3,char * arg4,int arg5);
extern void prim_setFillRule(Display* arg1,void * arg2,int arg3);
extern void prim_setFillStyle(Display* arg1,void * arg2,int arg3);
extern void prim_setFont(Display* arg1,void * arg2,XID arg3);
extern void prim_setLineAttributes(Display* arg1,void * arg2,int arg3,int arg4,int arg5,int arg6);
extern void prim_setPlaneMask(Display* arg1,void * arg2,unsigned int arg3);
extern void prim_setState(Display* arg1,void * arg2,unsigned int arg3,unsigned int arg4,int arg5,unsigned int arg6);
extern void prim_setStipple(Display* arg1,void * arg2,XID arg3);
extern void prim_setSubwindowMode(Display* arg1,void * arg2,int arg3);
extern void prim_setTSOrigin(Display* arg1,void * arg2,int arg3,int arg4);
extern void prim_setTile(Display* arg1,void * arg2,XID arg3);
extern void * prim_createGC(Display* arg1,XID arg2);
extern XID prim_gContextFromGC(void * arg1);
extern void prim_freeGC(Display* arg1,void * arg2);
extern void prim_flushGC(Display* arg1,void * arg2);
extern void prim_copyGC(Display* arg1,void * arg2,unsigned int arg3,void * arg4);
extern XID prim_createPixmap(Display* arg1,XID arg2,unsigned int arg3,unsigned int arg4,int arg5);
extern void prim_freePixmap(Display* arg1,XID arg2);
extern int prim_bitmapBitOrder(Display* arg1);
extern int prim_bitmapUnit(Display* arg1);
extern int prim_bitmapPad(Display* arg1);
extern void* prim_lookupColor(Display* arg1,XID arg2,char * arg3);
extern unsigned int access_prim_lookupColor_gc_res1(HsPtr);
extern unsigned int access_prim_lookupColor_gc_res3(HsPtr);
extern unsigned int access_prim_lookupColor_gc_res5(HsPtr);
extern unsigned int access_prim_lookupColor_gc_res7(HsPtr);
extern unsigned int access_prim_lookupColor_gc_res9(HsPtr);
extern unsigned int access_prim_lookupColor_gc_res10(HsPtr);
extern unsigned int access_prim_lookupColor_gc_res12(HsPtr);
extern unsigned int access_prim_lookupColor_gc_res14(HsPtr);
extern unsigned int access_prim_lookupColor_gc_res16(HsPtr);
extern unsigned int access_prim_lookupColor_gc_res18(HsPtr);
extern int access_prim_lookupColor_gc_failed(HsPtr);
extern void* access_prim_lookupColor_gc_failstring(HsPtr);
extern void* prim_allocNamedColor(Display* arg1,XID arg2,char * arg3);
extern unsigned int access_prim_allocNamedColor_gc_res1(HsPtr);
extern unsigned int access_prim_allocNamedColor_gc_res3(HsPtr);
extern unsigned int access_prim_allocNamedColor_gc_res5(HsPtr);
extern unsigned int access_prim_allocNamedColor_gc_res7(HsPtr);
extern unsigned int access_prim_allocNamedColor_gc_res9(HsPtr);
extern unsigned int access_prim_allocNamedColor_gc_res10(HsPtr);
extern unsigned int access_prim_allocNamedColor_gc_res12(HsPtr);
extern unsigned int access_prim_allocNamedColor_gc_res14(HsPtr);
extern unsigned int access_prim_allocNamedColor_gc_res16(HsPtr);
extern unsigned int access_prim_allocNamedColor_gc_res18(HsPtr);
extern int access_prim_allocNamedColor_gc_failed(HsPtr);
extern void* access_prim_allocNamedColor_gc_failstring(HsPtr);
extern void* prim_allocColor(Display* arg1,XID arg2,unsigned int gc_arg3,unsigned int gc_arg5,unsigned int gc_arg7,unsigned int gc_arg9,unsigned int gc_arg11);
extern unsigned int access_prim_allocColor_gc_res1(HsPtr);
extern unsigned int access_prim_allocColor_gc_res3(HsPtr);
extern unsigned int access_prim_allocColor_gc_res5(HsPtr);
extern unsigned int access_prim_allocColor_gc_res7(HsPtr);
extern unsigned int access_prim_allocColor_gc_res9(HsPtr);
extern int access_prim_allocColor_gc_failed(HsPtr);
extern void* access_prim_allocColor_gc_failstring(HsPtr);
extern void* prim_parseColor(Display* arg1,XID arg2,char * arg3);
extern unsigned int access_prim_parseColor_gc_res1(HsPtr);
extern unsigned int access_prim_parseColor_gc_res3(HsPtr);
extern unsigned int access_prim_parseColor_gc_res5(HsPtr);
extern unsigned int access_prim_parseColor_gc_res7(HsPtr);
extern unsigned int access_prim_parseColor_gc_res9(HsPtr);
extern int access_prim_parseColor_gc_failed(HsPtr);
extern void* access_prim_parseColor_gc_failstring(HsPtr);
extern void prim_freeColors(Display* arg1,XID arg2,unsigned long* arg3,int arg3_size,unsigned int arg4);
extern void prim_storeColor(Display* arg1,XID arg2,unsigned int gc_arg3,unsigned int gc_arg5,unsigned int gc_arg7,unsigned int gc_arg9,unsigned int gc_arg11);
extern void* prim_queryColor(Display* arg1,XID arg2,unsigned int gc_arg3,unsigned int gc_arg5,unsigned int gc_arg7,unsigned int gc_arg9,unsigned int gc_arg11);
extern unsigned int access_prim_queryColor_gc_res1(HsPtr);
extern unsigned int access_prim_queryColor_gc_res3(HsPtr);
extern unsigned int access_prim_queryColor_gc_res5(HsPtr);
extern unsigned int access_prim_queryColor_gc_res7(HsPtr);
extern unsigned int access_prim_queryColor_gc_res9(HsPtr);
extern void* prim_queryColors(Display* arg1,XID arg2,XColor* arg3,int arg3_size);
extern XColor* access_prim_queryColors_gc_res2(HsPtr);
extern int access_prim_queryColors_gc_res3(HsPtr);
extern void prim_installColormap(Display* arg1,XID arg2);
extern void prim_uninstallColormap(Display* arg1,XID arg2);
extern XID prim_copyColormapAndFree(Display* arg1,XID arg2);
extern XID prim_createColormap(Display* arg1,XID arg2,Visual* arg3,int arg4);
extern void prim_freeColormap(Display* arg1,XID arg2);
extern XFontStruct* prim_queryFont(Display* arg1,XID arg2);
extern void* prim_fontFromGC(Display* arg1,void * arg2);
extern XID access_prim_fontFromGC_gc_res1(HsPtr);
extern int access_prim_fontFromGC_gc_failed(HsPtr);
extern void* access_prim_fontFromGC_gc_failstring(HsPtr);
extern void* prim_loadQueryFont(Display* arg1,char * arg2);
extern XFontStruct* access_prim_loadQueryFont_res1(HsPtr);
extern int access_prim_loadQueryFont_gc_failed(HsPtr);
extern void* access_prim_loadQueryFont_gc_failstring(HsPtr);
extern void prim_freeFont(Display* arg1,XFontStruct* arg2);
extern XID prim_fontFromFontStruct(XFontStruct* arg1);
extern int prim_ascentFromFontStruct(XFontStruct* arg1);
extern int prim_descentFromFontStruct(XFontStruct* arg1);
extern void* prim_textExtents(XFontStruct* f,char * s,int s_len);
extern int access_prim_textExtents_direction(HsPtr);
extern int access_prim_textExtents_font_ascent(HsPtr);
extern int access_prim_textExtents_font_descent(HsPtr);
extern int access_prim_textExtents_gc_res3(HsPtr);
extern int access_prim_textExtents_gc_res4(HsPtr);
extern int access_prim_textExtents_gc_res5(HsPtr);
extern int access_prim_textExtents_gc_res6(HsPtr);
extern int access_prim_textExtents_gc_res7(HsPtr);
extern int prim_textWidth(XFontStruct* f,char * s,int s_len);
extern Atom prim_internAtom(Display* arg1,char * arg2,int arg3);
extern void* prim_displayKeycodes(Display* arg1);
extern int access_prim_displayKeycodes_res1(HsPtr);
extern int access_prim_displayKeycodes_res2(HsPtr);
extern XID prim_lookupKeysym(XKeyEvent* arg1,int arg2);
extern XID prim_keycodeToKeysym(Display* arg1,KeyCode arg2,int arg3);
extern KeyCode prim_keysymToKeycode(Display* arg1,XID arg2);
extern char * prim_keysymToString(XID arg1);
extern XID prim_stringToKeysym(char * arg1);
extern XID prim_noSymbol();
extern void* prim_lookupString(XKeyEvent* e);
extern XID access_prim_lookupString_ks(HsPtr);
extern char * access_prim_lookupString_buf(HsPtr);
extern int access_prim_lookupString_n(HsPtr);
extern void* prim_getIconName(Display* arg1,XID arg2);
extern char * access_prim_getIconName_res1(HsPtr);
extern int access_prim_getIconName_gc_failed(HsPtr);
extern void* access_prim_getIconName_gc_failstring(HsPtr);
extern void prim_setIconName(Display* arg1,XID arg2,char * arg3);
extern void prim_defineCursor(Display* arg1,XID arg2,XID arg3);
extern void prim_undefineCursor(Display* arg1,XID arg2);
extern XID prim_createPixmapCursor(Display* arg1,XID arg2,XID arg3,unsigned int gc_arg3,unsigned int gc_arg5,unsigned int gc_arg7,unsigned int gc_arg9,unsigned int gc_arg11,unsigned int gc_arg14,unsigned int gc_arg16,unsigned int gc_arg18,unsigned int gc_arg20,unsigned int gc_arg22,unsigned int arg6,unsigned int arg7);
extern XID prim_createGlyphCursor(Display* arg1,XID arg2,XID arg3,int arg4,int arg5,unsigned int gc_arg3,unsigned int gc_arg5,unsigned int gc_arg7,unsigned int gc_arg9,unsigned int gc_arg11,unsigned int gc_arg14,unsigned int gc_arg16,unsigned int gc_arg18,unsigned int gc_arg20,unsigned int gc_arg22);
extern XID prim_createFontCursor(Display* arg1,int arg2);
extern void prim_freeCursor(Display* arg1,XID arg2);
extern void prim_recolorCursor(Display* arg1,XID arg2,unsigned int gc_arg3,unsigned int gc_arg5,unsigned int gc_arg7,unsigned int gc_arg9,unsigned int gc_arg11,unsigned int gc_arg14,unsigned int gc_arg16,unsigned int gc_arg18,unsigned int gc_arg20,unsigned int gc_arg22);
extern void prim_setWMProtocols(Display* arg1,XID arg2,Atom * arg3,int arg3_size);
extern XSetWindowAttributes* prim_allocXSetWindowAttributes();
extern void prim_set_background_pixmap(XSetWindowAttributes* arg1,XID arg2);
extern void prim_set_background_pixel(XSetWindowAttributes* arg1,unsigned int arg2);
extern void prim_set_border_pixmap(XSetWindowAttributes* arg1,XID arg2);
extern void prim_set_border_pixel(XSetWindowAttributes* arg1,unsigned int arg2);
extern void prim_set_bit_gravity(XSetWindowAttributes* arg1,int arg2);
extern void prim_set_win_gravity(XSetWindowAttributes* arg1,int arg2);
extern void prim_set_backing_store(XSetWindowAttributes* arg1,int arg2);
extern void prim_set_backing_planes(XSetWindowAttributes* arg1,unsigned int arg2);
extern void prim_set_backing_pixel(XSetWindowAttributes* arg1,unsigned int arg2);
extern void prim_set_save_under(XSetWindowAttributes* arg1,int arg2);
extern void prim_set_event_mask(XSetWindowAttributes* arg1,unsigned int arg2);
extern void prim_set_do_not_propagate_mask(XSetWindowAttributes* arg1,unsigned int arg2);
extern void prim_set_override_redirect(XSetWindowAttributes* arg1,int arg2);
extern void prim_set_colormap(XSetWindowAttributes* arg1,XID arg2);
extern void prim_set_cursor(XSetWindowAttributes* arg1,XID arg2);
extern void prim_storeName(Display* arg1,XID arg2,char * arg3);
extern XID prim_createSimpleWindow(Display* arg1,XID arg2,int arg3,int arg4,unsigned int arg5,unsigned int arg6,int arg7,unsigned int arg8,unsigned int arg9);
extern XID prim_createWindow(Display* arg1,XID arg2,int arg3,int arg4,unsigned int arg5,unsigned int arg6,int arg7,int arg8,int arg9,Visual* arg10,unsigned int arg11,XSetWindowAttributes* arg12);
extern void* prim_translateCoordinates(Display* arg1,XID arg2,XID arg3,int arg4,int arg5);
extern int access_prim_translateCoordinates_res1(HsPtr);
extern int access_prim_translateCoordinates_res2(HsPtr);
extern int access_prim_translateCoordinates_res3(HsPtr);
extern XID access_prim_translateCoordinates_res4(HsPtr);
extern void prim_moveResizeWindow(Display* arg1,XID arg2,int arg3,int arg4,unsigned int arg5,unsigned int arg6);
extern void prim_resizeWindow(Display* arg1,XID arg2,unsigned int arg3,unsigned int arg4);
extern void prim_moveWindow(Display* arg1,XID arg2,int arg3,int arg4);
extern void prim_reparentWindow(Display* arg1,XID arg2,XID arg3,int arg4,int arg5);
extern void prim_mapSubwindows(Display* arg1,XID arg2);
extern void prim_unmapSubwindows(Display* arg1,XID arg2);
extern void prim_mapWindow(Display* arg1,XID arg2);
extern void prim_lowerWindow(Display* arg1,XID arg2);
extern void prim_raiseWindow(Display* arg1,XID arg2);
extern void prim_circulateSubwindowsDown(Display* arg1,XID arg2);
extern void prim_circulateSubwindowsUp(Display* arg1,XID arg2);
extern void prim_circulateSubwindows(Display* arg1,XID arg2,int arg3);
extern void* prim_iconifyWindow(Display* arg1,XID arg2,unsigned int arg3);
extern int access_prim_iconifyWindow_gc_failed(HsPtr);
extern void* access_prim_iconifyWindow_gc_failstring(HsPtr);
extern void* prim_withdrawWindow(Display* arg1,XID arg2,unsigned int arg3);
extern int access_prim_withdrawWindow_gc_failed(HsPtr);
extern void* access_prim_withdrawWindow_gc_failstring(HsPtr);
extern void prim_destroyWindow(Display* arg1,XID arg2);
extern void prim_destroySubwindows(Display* arg1,XID arg2);
extern void prim_setWindowBorder(Display* arg1,XID arg2,unsigned int arg3);
extern void prim_setWindowBorderPixmap(Display* arg1,XID arg2,XID arg3);
extern void prim_setWindowBorderWidth(Display* arg1,XID arg2,unsigned int arg3);
extern void prim_setWindowBackground(Display* arg1,XID arg2,unsigned int arg3);
extern void prim_setWindowBackgroundPixmap(Display* arg1,XID arg2,XID arg3);
extern void prim_setWindowColormap(Display* arg1,XID arg2,XID arg3);
extern void prim_addToSaveSet(Display* arg1,XID arg2);
extern void prim_removeFromSaveSet(Display* arg1,XID arg2);
extern void prim_changeSaveSet(Display* arg1,XID arg2,int arg3);
extern void prim_clearWindow(Display* arg1,XID arg2);
extern void prim_clearArea(Display* arg1,XID arg2,int arg3,int arg4,unsigned int arg5,unsigned int arg6,int arg7);
extern void prim_restackWindows(Display* arg1,Window* arg2,int arg2_size);
extern void prim_drawPoint(Display* arg1,XID arg2,void * arg3,int arg4,int arg5);
extern void prim_drawPoints(Display* arg1,XID arg2,void * arg3,XPoint* arg4,int arg4_size,int arg5);
extern void prim_drawLine(Display* arg1,XID arg2,void * arg3,int arg4,int arg5,int arg6,int arg7);
extern void prim_drawLines(Display* arg1,XID arg2,void * arg3,XPoint* arg4,int arg4_size,int arg5);
extern void prim_drawSegments(Display* arg1,XID arg2,void * arg3,XSegment* arg4,int arg4_size);
extern void prim_drawRectangle(Display* arg1,XID arg2,void * arg3,int arg4,int arg5,unsigned int arg6,unsigned int arg7);
extern void prim_drawRectangles(Display* arg1,XID arg2,void * arg3,XRectangle* arg4,int arg4_size);
extern void prim_drawArc(Display* arg1,XID arg2,void * arg3,int arg4,int arg5,unsigned int arg6,unsigned int arg7,int arg8,int arg9);
extern void prim_drawArcs(Display* arg1,XID arg2,void * arg3,XArc* arg4,int arg4_size);
extern void prim_fillRectangle(Display* arg1,XID arg2,void * arg3,int arg4,int arg5,unsigned int arg6,unsigned int arg7);
extern void prim_fillRectangles(Display* arg1,XID arg2,void * arg3,XRectangle* arg4,int arg4_size);
extern void prim_fillPolygon(Display* arg1,XID arg2,void * arg3,XPoint* arg4,int arg4_size,int arg5,int arg6);
extern void prim_fillArc(Display* arg1,XID arg2,void * arg3,int arg4,int arg5,unsigned int arg6,unsigned int arg7,int arg8,int arg9);
extern void prim_fillArcs(Display* arg1,XID arg2,void * arg3,XArc* arg4,int arg4_size);
extern void prim_copyArea(Display* arg1,XID arg2,XID arg3,void * arg4,int arg5,int arg6,unsigned int arg7,unsigned int arg8,int arg9,int arg10);
extern void prim_copyPlane(Display* arg1,XID arg2,XID arg3,void * arg4,int arg5,int arg6,unsigned int arg7,unsigned int arg8,int arg9,int arg10,unsigned int arg11);
extern void prim_drawString(Display* arg1,XID arg2,void * arg3,int arg4,int arg5,char * arg6,int arg6_size);
extern void prim_drawImageString(Display* arg1,XID arg2,void * arg3,int arg4,int arg5,char * arg6,int arg6_size);
extern void* prim_storeBuffer(Display* arg1,char * arg2,int arg2_size,int arg3);
extern int access_prim_storeBuffer_gc_failed(HsPtr);
extern void* access_prim_storeBuffer_gc_failstring(HsPtr);
extern void* prim_storeBytes(Display* arg1,char * arg2,int arg2_size);
extern int access_prim_storeBytes_gc_failed(HsPtr);
extern void* access_prim_storeBytes_gc_failstring(HsPtr);
extern void* prim_fetchBuffer(Display* arg1,int arg2);
extern char * access_prim_fetchBuffer_res1(HsPtr);
extern int access_prim_fetchBuffer_nbytes(HsPtr);
extern int access_prim_fetchBuffer_gc_failed(HsPtr);
extern void* access_prim_fetchBuffer_gc_failstring(HsPtr);
extern void* prim_fetchBytes(Display* arg1);
extern char * access_prim_fetchBytes_res1(HsPtr);
extern int access_prim_fetchBytes_nbytes(HsPtr);
extern int access_prim_fetchBytes_gc_failed(HsPtr);
extern void* access_prim_fetchBytes_gc_failstring(HsPtr);
extern void* prim_rotateBuffers(Display* arg1,int arg2);
extern int access_prim_rotateBuffers_gc_failed(HsPtr);
extern void* access_prim_rotateBuffers_gc_failstring(HsPtr);
extern Atom prim_a_PRIMARY();
extern Atom prim_a_SECONDARY();
extern Atom prim_a_ARC();
extern Atom prim_a_ATOM();
extern Atom prim_a_BITMAP();
extern Atom prim_a_CARDINAL();
extern Atom prim_a_COLORMAP();
extern Atom prim_a_CURSOR();
extern Atom prim_a_CUT_BUFFER0();
extern Atom prim_a_CUT_BUFFER1();
extern Atom prim_a_CUT_BUFFER2();
extern Atom prim_a_CUT_BUFFER3();
extern Atom prim_a_CUT_BUFFER4();
extern Atom prim_a_CUT_BUFFER5();
extern Atom prim_a_CUT_BUFFER6();
extern Atom prim_a_CUT_BUFFER7();
extern Atom prim_a_DRAWABLE();
extern Atom prim_a_FONT();
extern Atom prim_a_INTEGER();
extern Atom prim_a_PIXMAP();
extern Atom prim_a_POINT();
extern Atom prim_a_RECTANGLE();
extern Atom prim_a_RESOURCE_MANAGER();
extern Atom prim_a_RGB_COLOR_MAP();
extern Atom prim_a_RGB_BEST_MAP();
extern Atom prim_a_RGB_BLUE_MAP();
extern Atom prim_a_RGB_DEFAULT_MAP();
extern Atom prim_a_RGB_GRAY_MAP();
extern Atom prim_a_RGB_GREEN_MAP();
extern Atom prim_a_RGB_RED_MAP();
extern Atom prim_a_STRING();
extern Atom prim_a_VISUALID();
extern Atom prim_a_WINDOW();
extern Atom prim_a_WM_COMMAND();
extern Atom prim_a_WM_HINTS();
extern Atom prim_a_WM_CLIENT_MACHINE();
extern Atom prim_a_WM_ICON_NAME();
extern Atom prim_a_WM_ICON_SIZE();
extern Atom prim_a_WM_NAME();
extern Atom prim_a_WM_NORMAL_HINTS();
extern Atom prim_a_WM_SIZE_HINTS();
extern Atom prim_a_WM_ZOOM_HINTS();
extern Atom prim_a_MIN_SPACE();
extern Atom prim_a_NORM_SPACE();
extern Atom prim_a_MAX_SPACE();
extern Atom prim_a_END_SPACE();
extern Atom prim_a_SUPERSCRIPT_X();
extern Atom prim_a_SUPERSCRIPT_Y();
extern Atom prim_a_SUBSCRIPT_X();
extern Atom prim_a_SUBSCRIPT_Y();
extern Atom prim_a_UNDERLINE_POSITION();
extern Atom prim_a_UNDERLINE_THICKNESS();
extern Atom prim_a_STRIKEOUT_ASCENT();
extern Atom prim_a_STRIKEOUT_DESCENT();
extern Atom prim_a_ITALIC_ANGLE();
extern Atom prim_a_X_HEIGHT();
extern Atom prim_a_QUAD_WIDTH();
extern Atom prim_a_WEIGHT();
extern Atom prim_a_POINT_SIZE();
extern Atom prim_a_RESOLUTION();
extern Atom prim_a_COPYRIGHT();
extern Atom prim_a_NOTICE();
extern Atom prim_a_FONT_NAME();
extern Atom prim_a_FAMILY_NAME();
extern Atom prim_a_FULL_NAME();
extern Atom prim_a_CAP_HEIGHT();
extern Atom prim_a_WM_CLASS();
extern Atom prim_a_WM_TRANSIENT_FOR();
extern Atom prim_a_LAST_PREDEFINED();
extern void prim_setTextProperty(Display* arg1,XID arg2,char * arg3,int arg3_size,Atom arg4);
extern int prim_rectangleOut();
extern int prim_rectangleIn();
extern int prim_rectanglePart();
extern void* prim_createRegion();
extern void* access_prim_createRegion_gc_res3(HsPtr);
extern Region access_prim_createRegion_gc_res1(HsPtr);
extern void* prim_polygonRegion(XPoint* arg1,int arg2,int arg3);
extern void* access_prim_polygonRegion_gc_res3(HsPtr);
extern Region access_prim_polygonRegion_gc_res1(HsPtr);
extern int prim_intersectRegion(Region arg1,Region arg2,Region arg3);
extern int prim_subtractRegion(Region arg1,Region arg2,Region arg3);
extern int prim_unionRectWithRegion(int gc_arg3,int gc_arg5,unsigned int gc_arg6,unsigned int gc_arg7,Region arg2,Region arg3);
extern int prim_unionRegion(Region arg1,Region arg2,Region arg3);
extern int prim_xorRegion(Region arg1,Region arg2,Region arg3);
extern int prim_emptyRegion(Region arg1);
extern int prim_equalRegion(Region arg1,Region arg2);
extern int prim_pointInRegion(Region arg1,int gc_arg4,int gc_arg6);
extern int prim_rectInRegion(Region arg1,int gc_arg4,int gc_arg6,unsigned int gc_arg7,unsigned int gc_arg8);
extern void* prim_clipBox(Region arg1);
extern int access_prim_clipBox_gc_res2(HsPtr);
extern int access_prim_clipBox_gc_res4(HsPtr);
extern unsigned int access_prim_clipBox_gc_res5(HsPtr);
extern unsigned int access_prim_clipBox_gc_res6(HsPtr);
extern int access_prim_clipBox_res2(HsPtr);
extern int prim_offsetRegion(Region arg1,int gc_arg4,int gc_arg6);
extern int prim_shrinkRegion(Region arg1,int gc_arg4,int gc_arg6);
extern int prim_setRegion(Display* arg1,void * arg2,Region arg3);
#endif
